// Functions for validation and preloading or AR form data
// Created By: Phil Hannent
// Created On: 12th January 2004
// Updated By: Phil Hannent
// Updated On: 1st April 2005 - Added file upload
// Updated On: October 2013 Prehelp.... routines for help on AR checklist questions

function submitME(){
	if ((document.frmAR.hidSubmitted.value == "1") && (document.frmAR.hidReadOnly.value == "N")) {
 		alert("Your duplicate request has been ignored,\nas you have used the browser back button");
	} else {
	  document.frmAR.hidSubmitted.value = "1";
	  document.frmAR.submit();
	  return(true);
	}
}

function ShowAction(ActionID) {
//  Show the action in a new window
//        var openurl='MIRAppActionView.asp?ActNo=' + ActionID;
        var d = new Date();
        var openurl='MIRAppActionView.asp?ActNo=' + ActionID + '&T=' + d.getTime();
        var win = window.open(openurl, 'Action', 'width=800,height=600,status=no,dependent=yes,resizable=yes,scrollbars=yes,screenX=0,screenY=0');
        win.focus();
}

function hideActions() {
	if (document.frmAR.hidShowActions.value == "Y") {
		document.frmAR.hidShowActions.value = "N";
	} else {
		document.frmAR.hidShowActions.value = "Y";
	}
}

function hidePrevAudits() {
	if (document.frmAR.hidShowPrev.value == "Y") {
		document.frmAR.hidShowPrev.value = "";
	} else {
		document.frmAR.hidShowPrev.value = "Y";
	}
}


function checkTime(time_value) {
	if (time_value.value != '') {
		// Makes sure the time is in format hh:mm or h:mm
		 var pattern = '^([0-1]?[0-9]|[2][0-3])[:.]([0-5][0-9])$'
		 var matches = ExtractMatches( new RegExp( pattern, "gi" ), time_value.value )
		 
		 if (matches.length > 0) {
			 // The string passed the test
			 return true;
		 } else {
			 // The string failed the test
			 alert('Invalid time format\n\nPlease use hh:mm');
			 time_value.focus();
			 return false;
		 }
	}
}

function ExtractMatches( re, text )
	{
		var results = new Array() ;
		var arr = re.exec(text)
		while(arr != null)
		{ 
			var match = new Match() ;
			match.Text = arr[0] ;
					
			for (var i=1; i<arr.length; i++)
			{
				match.Groups[i-1] = arr[i] ;
			}
			
			results[results.length] = match ;
			arr = re.exec(text) ; 
		}
		return results ;
	}
	
	function Match()
	{
		this.Text = null ;
		this.Groups = new Array() ;
	}
	

function fileUpload(lARID) {
// Check that the user isn't trying to upload a filename that already exists
	var sFileName
	var bFound;
	if (document.frmAR.filegeneral.value == '')  {
		return(false);
	} else {
		sFileName = getFileName(document.frmAR.filegeneral.value);
		bFound = 'N';
		if (findInArray(sFileName, aFiles)) {
			if (confirm('A duplicate filename has been found.\nClick OK to replace the existing file')) {
				bFound = 'N';
			} else {
				bFound = 'Y';
			}
		} 
		
		if (bFound == 'N') {
			// The user wants to upload the file
			ColourInUseStyle(this); 
			document.frmAR.encoding='multipart/form-data';
			document.frmAR.action='MIRAPPARuploadreturn.asp?hidAuditSysID=' + lARID;
		} else {
			// The user doesn't want to upload the file
			return(false);
		}
	}
}

function DeleteThis(sID) {
    document.all.DELETETHIS.value=sID;
    return(submitME());
}

function CheckDelete(snamefile) {
//  Ask the user if they really want to delete the document
    if (confirm('You are about to delete\n' + snamefile + '\nIs this ok?')) {
        document.frmAR.DELETETHIS.value=snamefile;
        return(submitME());
    } else {
		return(false);
    }
}


function PreHelpQuestions(lChecklistID) {
	// display the help for the selected Question
	SHelp('helper' + lChecklistID);
	return(false);

}


function PreHelpQuestionsClose(lChecklistID) {
	// Hide the help for the selected question
	thehelpwin = 1 ? document.getElementById('helper' + lChecklistID).style:document.getElementById('helper' + lChecklistID); 
	if (thehelpwin.visibility == 'visible' || thehelpwin.visibility == 'show') { 
		// Window is being shown, so hide it

		// leave help showing if it has a link
		sinner = document.getElementById('helper' + lChecklistID).innerHTML
		pattern = new RegExp("<A ");
		if (!pattern.test(sinner)) {
			SHelp('helper' + lChecklistID);
		}
	}
	return(false);
}

function SHelp(IDtoShow) {
		var wp = window.innerWidth != null? window.innerWidth: document.body.clientWidth != null? document.body.clientWidth:null;
		thehelpwin = 1 ? document.getElementById(IDtoShow).style:document.getElementById(IDtoShow); 
		dm = 0 ? document.getElementById(IDtoShow).style:document.getElementById(IDtoShow); 

		if (dm.offsetWidth) {
			ew = dm.offsetWidth; 
		}
		else  {
			if (dm.clip.width) {
				ew = dm.clip.width; 
			}			
		}

		if (thehelpwin.visibility == 'visible' || thehelpwin.visibility == 'show') { 
			thehelpwin.visibility = 'hidden'; 
		        showElement( 'SELECT' );
		        showElement( 'APPLET' );
		} 

		else {
			topposn = mouseY(event) + 20; 
			leftposn = mouseX(event) - (ew/4); 

			if (leftposn < 2) {
				leftposn = 2;
			} 
			else { 
				if (leftposn + ew > wp) { 
					leftposn -= ew/2; 
				}
			}

			leftposn += 'px';
			topposn += 'px';

			thehelpwin.left = leftposn; 
			thehelpwin.top = topposn; 

			hideElement( 'SELECT', document.getElementById(IDtoShow) );
			hideElement( 'APPLET', document.getElementById(IDtoShow) );			

			thehelpwin.visibility = 'visible';
		}
}
function mouseX(evt) {
	if (evt.pageX) {
		return evt.pageX; 
	}
	else
	{ 
		if (evt.clientX) {
			return evt.clientX + (document.documentElement.scrollLeft ?  document.documentElement.scrollLeft : document.body.scrollLeft); 
		}
		else {
			return null;
		}
	}
}

function mouseY(evt) {
	if (evt.pageY) {
		return evt.pageY; 
		}
	else {
		if (evt.clientY) {
			return evt.clientY + (document.documentElement.scrollTop ? document.documentElement.scrollTop : document.body.scrollTop); 
		}
		else {
			return null;
		}
	}
}