
Date.prototype.addHours= function(h){
    this.setHours(this.getHours()+h);
    return this;
}

function init_scheduler_base() {

    scheduler.config.server_utc = true;

    scheduler.attachEvent("onClick", function (id, e){
       scheduler.showLightbox(id);
       return true;
    });
    scheduler.attachEvent("onEmptyClick", function (date, e){
        var eventId = scheduler.addEventNew({
            start_date: date,
            end_date:   date.addHours(1),
            text:   "New Event"
        });
        //scheduler.showLightbox(eventId);
    });
    scheduler.attachEvent('onConfirmedBeforeEventDelete', function(id, ev){
        var return_value = '{ \"action\": \"DELETE\", \"id\": \"' + id + '\"';
        return_value += '}';
        var return_obj = jQuery.parseJSON(return_value);
        $.post( '/scheduler/scheduler.asp?q=process_data&m=' + obj_module_name, return_obj );
        scheduler.endLightbox(false);
        return true;
    });
    scheduler.attachEvent('onEventAdded', function(id,ev){
    //    alert('onEventAdded');
        return post_back_event('CREATE', ev);
        return true;
    });

    scheduler.attachEvent('onEventChanged',function(id,ev){
        alert('onEventChanged: ' + scheduler.getEvent(id).start_date);
        return post_back_event('UPDATE', ev);
    });

    function post_back_event(action_type, ev){
        ev.saved = false;
        var return_value = '{ \"action\": \"' + action_type + '\", \"id\": \"' + ev.id + '\"';
        return_value += ', \"text\": \"' + ev.text + '\"';
        for (var i = 0; i < scheduler.post_back_dynamic_data.length; ++i) {
            return_value += ', \"' + scheduler.post_back_dynamic_data[i] + '\": \"' + ev[scheduler.post_back_dynamic_data[i]] + '\"';
        }
        return_value += ', \"rec_type\": \"' + ev.rec_type + '\"';
        return_value += ', \"event_pid\": \"' + ev.event_pid + '\"';
        return_value += ', \"event_length\": \"' + ev.event_length + '\"';
        return_value += ', \"start_date\": \"' + ev.start_date.toLocaleString() + '\"';
        return_value += ', \"end_date\": \"' + ev.end_date.toLocaleString() + '\"';
        return_value += '}';
        //alert(return_value);
        var return_obj = jQuery.parseJSON(return_value);
        var return_valid = 'No response from server';
        var returned_json;
        var accept_change = false;
        ev.posted = true;
        $.ajax({
          type: 'POST',
          url: '/scheduler/scheduler.asp?q=validate_change&m=' + obj_module_name,
          data: return_obj,
          success: function(html) { return_valid = ''; returned_json = html;},
          async:false
        });
        if (return_valid != '') {
            alert('There was a problem with your change:\n' + return_valid);
        } else {
            //alert(returned_json);
            var json_object = jQuery.parseJSON(returned_json);
            if (json_object.action == 'invalid') {
                var err_msg = '';
                for (var i = 0; i < json_object.error.length; ++i) { 
                    err_msg += json_object.error[i].msg + '\n';
                }
                alert('There was a problem with your change:\n' + err_msg);
            } else {
                scheduler.changeEventId(ev.id, json_object.event_id);
                var updated_ev = scheduler.getEvent(json_object.event_id);
                accept_change = true;
                ev.saved = true;
            }
        }
        return accept_change;
    }
    scheduler.attachEvent("onEventLoading", function(ev){
        /* If the start date and the end date are in the past these are read only,
        ** if this is a reoccurring event and the end date is not in the past this is
        ** not read only */
        if (((ev.start_date < new Date()) && (ev.rec_type == undefined || ev.rec_type == ''))
            || ((ev.start_date < new Date()) && (ev.end_date < new Date())))
            ev.readonly=true;
        return true;
    });
    scheduler.attachEvent("onBeforeDrag", function (id, mode, e){
        if (id == null) return true;
        if (scheduler.getEvent(id).start_date < new Date())
            return false;
        return true;
    });
}